/*
 * AboutBox Dialog
 *
 * Author: M. Heidi McClure
 * Date Started: 9/1/96
 * Date Last Revised: 4/12/97
 *
 */

import java.awt.*;

/**
 * This class just displays an about
 * UTMOST2 dialog.
 *
 * @author      M. Heidi McClure
 * @version UTMOST2 1.0
 * @see UTMOST2
 */
class AboutBox extends Dialog {

    Label label1;
    Label label2;
    Label label3,label4,label5;
    Button OKButton;

    /**
     * Constructor which will display the About dialog box.
     *
     * @param parent is the caller of this class.
     */
    public AboutBox(Frame parent) {
        super(parent, "About", true);
        setResizable(false);

        setLayout(new GridLayout(6,1));
        addNotify();
        resize( insets().left + insets().right + 392,
                insets().top + insets().bottom + 180);
        label1=new Label("RACEWIN V1.0");
        add(label1);
        label1.reshape( insets().left + 12,
                        insets().top + 18,
                        274,
                        16);
        label2=new Label("written by M. Heidi McClure");
        add(label2);
        label2.reshape( insets().left + 12,
                        insets().top + 36,
                        274,
                        16);
		label4=new Label ("and Jonas E. Hedlind");
		add(label4);
        label3=new Label("Comments/Corrections to mhmcclur@elbert.uccs.edu,");
        add(label3);
        label3.reshape( insets().left + 12,
                        insets().top + 54,
                        274,
                        16);
		label5=new Label("jehedlin@mail.uccs.edu");
		add(label5);
        OKButton=new Button("OK");
        add(OKButton);
        OKButton.reshape(insets().left + 204,insets().top + 12,72,26);
    }

    public synchronized void show() {
        Rectangle bounds = getParent().bounds();
        Rectangle abounds = bounds();

        move(   bounds.x + (bounds.width - abounds.width)/ 2,
                bounds.y + (bounds.height - abounds.height)/2);

        super.show();
    }

    public synchronized void wakeUp() {
        notify();
    }

    /**
     * handleEvent is for handling mouse, keystroke, Window, ScrollBar,
     * List and some action events.  Geary, pg. 69
     * This handleEvent has button actions in it... these should be in
     * an action method.  This may be why under some OS's the buttons
     * don't behave correctly? in these dialogs
     */
    public boolean handleEvent(Event event) {
        if (event.id == Event.ACTION_EVENT && event.target == OKButton) {
            clickedOKButton();
            return true;
        } else if (event.id == Event.WINDOW_DESTROY) {
            hide();
            return true;
        }
        return super.handleEvent(event);
    }

    public void clickedOKButton() {
        handleEvent(new Event(this, Event.WINDOW_DESTROY, null));
    }
}


