/*
 * FilesPanel class
 *
 * Author: M. Heidi McClure
 * Date Started: 3/12/97
 * Date Last Revised: 4/12/97
 */
import java.awt.*;
// import java.io.*; // for DataInputStream
// import java.util.*; // for StringTokenizer

public class FilesPanel extends Panel {
    private Label PanelTitle = new Label("Files Used by UTMOST2");

    private Label fActivityFileLabel =        new Label("User Activity File:");
    private TextField fActivityFileText =   new TextField("activity_data1");
    private Button fActivityFileBrowse = new Button("Browse...");

    private Label fBoundaryFileLabel =       new Label("Boundary Cross File:");
    private TextField fBoundaryFileText =   new TextField("boundary_data1");
    private Button fBoundaryFileBrowse=new Button("Browse...");

    private Label fLogFileLabel =       new Label("Console Log File:");
    private TextField fLogFileText =   new TextField("console_log");
    private Button fLogFileBrowse=new Button("Browse...");

    private PropertySettings parent;
    private String activityFile;
    private String boundaryFile;
    private String logFile;

    public FilesPanel(PropertySettings p) {
        parent = p;
        activityFile = null;
        boundaryFile = null;
        logFile = null;
        /*
         * Layouts for this panel done by using Symantec Cafe's Studio
         * resource builder tool
         */

        setLayout(null);

        resize(insets().left + insets().right + 462, insets().top + insets().bottom + 306);

        add(PanelTitle);
        PanelTitle.reshape(insets().left + 24,insets().top + 24,200,20);

        add(fActivityFileLabel);
        fActivityFileLabel.reshape(insets().left + 24,insets().top + 60,160,20);
        add(fActivityFileText);
        fActivityFileText.reshape(insets().left + 24,insets().top + 80,320,30);
        add(fActivityFileBrowse);
        fActivityFileBrowse.reshape(insets().left + 360,insets().top + 80,88,30);

        add(fBoundaryFileLabel);
        fBoundaryFileLabel.reshape(insets().left + 24,insets().top + 116,160,20);
        add(fBoundaryFileText);
        fBoundaryFileText.reshape(insets().left + 24,insets().top + 136,320,30);
        add(fBoundaryFileBrowse);
        fBoundaryFileBrowse.reshape(insets().left + 360,insets().top + 136,88,30);

        add(fLogFileLabel);
        fLogFileLabel.reshape(insets().left + 24,insets().top + 172,160,20);
        add(fLogFileText);
        fLogFileText.reshape(insets().left + 24,insets().top + 192,320,30);
        add(fLogFileBrowse);
        fLogFileBrowse.reshape(insets().left + 360,insets().top + 192,88,30);

    }

    public void setParent(PropertySettings p) {
        parent = p;
    }
    public void setActivityFile(String s) {
        activityFile = s;
    }
    public void setBoundaryFile(String s) {
        boundaryFile = s;
    }
    public void setLogFile(String s) {
        logFile = s;
    }

    /*
     * action() method is for handling Button, TextField, Choice
     * and CheckBox action events ONLY. Geary, pg. 72 and 82-.
     */
    public boolean action(Event evt, Object arg) {

        if (evt.target == fActivityFileText) {
            activityFile = fActivityFileText.getText();
        }

        if (evt.target == fBoundaryFileText) {
            boundaryFile = fBoundaryFileText.getText();
        }

        if (evt.target == fLogFileText) {
            logFile = fLogFileText.getText();
        }

        return true;
    }

    public void updateValues() {
        /*
            activityFile = fActivityFileText.getText();
            boundaryFile = fBoundaryFileText.getText();
            logFile = fLogFileText.getText();
        */
    }

}

