/*
 * PowCtrlPanel class
 *
 * Author: Jonas Hedlind
 * Date Started: 06/97
 * Date Last Revised: 07/97
 */
import java.awt.*;
/**
 * 
 * <p>
 * @author      Jonas Hedlind
 * @version RACEWIN 1.0
 * @see VariablesPanel
 * @see FilesPanel
 * @see SectorPanel
 * @see PropertySettings
 */
public class ImagePanel extends Panel 
{
	private Label PanelTitle = new Label("Image Control");
	private Label imageLabel = new Label("Show Image");
	private TextField     imageNameText = new TextField("Test.gif");
	private Button		  imageBrowseButton = new Button("Browse..");
	    
	private Label         imageXoffsetLabel = new Label("Image Xoffset");
	private TextField     imageXoffsetText = new TextField("0");
	private Label         imageYoffsetLabel = new Label("Image Yoffset");
	private TextField     imageYoffsetText = new TextField("0");
	
	private Checkbox	  imageLoadCheck = new Checkbox();

	private PropertySettings parent;
	private UTMOST2 the;
	private String name;
    /**
     * Constructor which will create a PowCtrlPanel object.
     *
     * @param p is the PropertySettings panel object which called this
     * constructor
     */
    public ImagePanel(PropertySettings p) 
	{
        parent = p;
		the = p.getUTMOST2();

               
        setLayout(null);

        resize(insets().left + insets().right + 462, insets().top + insets().bottom + 306);

        add(PanelTitle);
        PanelTitle.reshape(insets().left + 24,insets().top + 24,200,20);

		add(imageLoadCheck);
        imageLoadCheck.reshape(insets().left + 24,insets().top + 60,90,30);
		imageLoadCheck.setLabel("Load Image");
		imageLoadCheck.setState(false);

        add(imageLabel);
        imageLabel.reshape(insets().left + 24,insets().top + 120,100,20);
        add(imageNameText);
        imageNameText.reshape(insets().left + 130,insets().top + 120,200,30);
        add(imageBrowseButton);
        imageBrowseButton.reshape(insets().left + 340,insets().top + 120,88,30);

        add(imageXoffsetLabel);
        imageXoffsetLabel.reshape(insets().left + 24,insets().top + 180,160,20);
        add(imageXoffsetText);
        imageXoffsetText.reshape(insets().left + 200,insets().top + 180,60,30);
        

        add(imageYoffsetLabel);
        imageYoffsetLabel.reshape(insets().left + 24,insets().top + 250,160,20);
        add(imageYoffsetText);
        imageYoffsetText.reshape(insets().left + 200,insets().top + 250,60,30);
        


    }



    public void setParent(PropertySettings p)
	{
        parent = p;
    }

   	private int getImageXoffset(){
		int v = Integer.parseInt(imageXoffsetText.getText());
		if (v > 0 )
			return v;
		else{
			imageXoffsetText.setText("0");
			return (0);
		}
	}

	private int getImageYoffset(){
		int v = Integer.parseInt(imageYoffsetText.getText());
		if (v > 0 )
			return v;
		else{
			imageYoffsetText.setText("0");
			return (0);
		}
	}


	  
   /*
     * action() method is for handling Button, TextField, Choice
     * and CheckBox action events ONLY. Geary, pg. 72 and 82-.
     */
    public boolean action(Event evt, Object arg) 
	{
		//setPowCtrlType(PowerControlChoice.getSelectedIndex());
		if(evt.target == imageBrowseButton){
			FileDialog filename = new FileDialog(the, "Open...",FileDialog.LOAD);
			filename.setFile("*.gif;*.jpg");
			filename.show();
			name = filename.getFile();
			if(name != null){
				imageNameText.setText(name);
				the.map.setupImage();
			}
			
		}
		

		updateValues();
        return true;
    }

    public void updateValues() 
	{
        the.ImageName = imageNameText.getText();
		the.imageX = getImageXoffset();
		the.imageY = getImageYoffset();
		the.drawImage=imageLoadCheck.getState();
	}
}

