/*POCAT */

import java.io.*;
import java.util.*;

public class POCAT
{
	//private int users;
	private int basestations;
	private int usrs;
	
	//private String date;
	private StringBuffer channelAssignment = new StringBuffer();
	private StringBuffer fileName= new StringBuffer();
	private StringBuffer doneFileName= new StringBuffer();
	private UTMOST2 the;
	private POCATSettings set;

	public static int GoAgain = 1; //modes
	public static int Go = 0;

	PrintStream fdone;
	PrintStream	fpower;
	
	public POCAT(UTMOST2 t,POCATSettings p,String d)
	{
		the=t;
		set=p;
		usrs=the.map.getNumUsers();
		channelAssignment.setLength(0);
		channelAssignment.append("other_sim_files" + the.FILE_SEP +
                                     "chan_assign" + the.FILE_SEP + d);
		if (!(new File(channelAssignment.toString()).exists())) 
                    new File(channelAssignment.toString()).mkdirs();
		channelAssignment.append(the.FILE_SEP);
	}

	public void calcNextStep(int step,int mode)
	{
		the.asNeededPrintln("POCAT ....");
		for(int i=0;i < usrs;i++)
		{
			char c = the.users[i].getIsCallingDRC();
			if( c == 'R' || c== 'C')
			{
					the.users[i].calcPathloss(set.getFadingModel());
					the.users[i].setCurPower(0.5); //initial power
					the.users[i].calcPossibleAnt(3,4500);
			}
			//for(int i=0;i<the.sectors.length;i++)
			//	sect[i].serving=0;
			if(mode == Go)
			{
				for(int j=0;j< the.users[i].getCurNumber()-1;j++)
				{
					the.users[i].setPrevHandoff(j,the.users[i].getCurHandoff(j));
				}
				the.users[i].setPrevNumber(the.users[i].getCurNumber());
			}
		}
		calcNewPower(usrs);
		fileName.setLength(0); 
		fileName.append(channelAssignment.toString() + step);
		writeResult(step);
		doneFileName.setLength(0);
		doneFileName.append(channelAssignment.toString() + step + "done");

		// create and close the done file for this step
        try 
		{
			fdone = new PrintStream(
            new FileOutputStream(doneFileName.toString()));
        } 
		catch (Exception e) 
		{
            the.asNeededPrintln("Problem when opening " +
		    doneFileName.toString());
        }
        fdone.close();
		the.asNeededPrintln("POCAT ....DONE");
	}
	
	private void calcNewPower(int usrs)
	{
		int count=0,min_base=0,tmp;
		double totalp=0,oldtp=0,mpower,power;
		double pow_dif = 1e-6;
		//int [] soft = new int [6];
		double [] nextp =  new double [5000];

		
		/* Algorithm */
		do
		{
			oldtp=totalp;
			totalp=0;
			for(int i=0;i<usrs;i++)
			{
				//for(j=0;j<user[i].nr_assigned;j++) /* Deallocate */
				//	sector_stat(user[i].antennas[j],2); 
				if(the.users[i].getIsCallingDRC()=='C' || 
					the.users[i].getIsCallingDRC()=='R')
				{
					mpower = 5e10;
					for(int k=0; k< the.sector.length; k++)
					{
						if(the.users[i].IsPossibleAnt(k/3)==1 && 
							the.users[i].IsVisible(k)==1)// && sector_stat(k,0)) /*  */
						{
							double ii=0;
							for(int j=0;j<usrs;j++)
							{/*how about Interference caused by roaming users ??*/
								if(j!=i && the.users[j].IsVisible(k)==1)
									ii+=the.users[j].getPathloss(k)*the.users[j].getCurPower();
							}
							ii+=set.getNoise();
							power=(set.getCir() * ii) / the.users[i].getPathloss(k);
							if(power < mpower) 
							{
								mpower = power; /*save lowest power*/
								min_base = k;
							}
						}
					}
					if(mpower <= set.getMaxPower())
					{
						//sector_stat(min_base,1); /*Reserve */
						if(mpower > set.getMinPower())
							nextp[i]=mpower;
						else
							nextp[i]=set.getMinPower();
					
						the.users[i].setCurAntenna(min_base);
						totalp+=mpower;
					}
					else /*Power too high, user is dropped */
					{
						nextp[i]=0;
						the.users[i].setCurAntenna(-1);
						the.users[i].setCurNumber(1);
						totalp+=1;
					}
				}
			}
			for(int i=0;i<usrs;i++)
			{
				the.users[i].setCurPower(nextp[i]);
			}
			count++;
		}while(Math.abs(oldtp-totalp) > pow_dif && count< set.getMaxReps());

		for(int i=0;i<usrs;i++)
		{
			the.users[i].setCurNumber(0);
			if((tmp=softer_handoff(i,the.users[i].getCurAntenna()))>0)
			{	
				the.users[i].setCurNumber(tmp);
			}
			else /*user assigned to one */
			{
				the.users[i].setCurNumber(1);
			}
		}
		//if(debug)
		//	printf("%d reps, pow_dif=%e\n",count,fabs(oldtp-totalp));	
	}

	private int softer_handoff(int usr,int ant)
	{
	int i,j=0,k=0;
	double difference;
	
		/*Softer*/
		for(i=(ant/3)*3;i< (ant/3)*3+3;i++)
		{
			if(i!=ant && the.users[usr].IsVisible(i)==1 && i/3 == ant/3 && j<5)
			{
			//	difference=(the.users[usr].getPathloss(ant) - the.users[usr].getPathloss(i))
			//		/the.users[usr].getPathloss(ant);
			//	if(difference < 0)
			//		difference=-difference;
			//	if(difference <= set.getHandoffThreshold())
			//	{
					//if(sector_stat(i,1)) /*Reserve*/
						the.users[usr].setCurHandoff(j,i);
						j++;
			//	}
			}
		}
		/*if(j>0)
		{
			//user[usr].handoff=1;
		}*/
		k=j;
		/* soft */
		for(i=0;i<the.sector.length ;i++)
		{
			if(the.users[usr].IsPossibleAnt(i/3)==1 && 
				the.users[usr].IsVisible(i)==1 && i/3 != ant/3 && k<5)
			{
		 /*softpair(ant,i))*/
				difference=(the.users[usr].getPathloss(ant) - the.users[usr].getPathloss(i))
					/the.users[usr].getPathloss(ant);
				if(difference <= set.getHandoffThreshold() || difference < 0)
				{
					//if(sector_stat(i,1)) /*Reserve*/
						the.users[usr].setCurHandoff(k,i);
						k++;
				}
			}
		}
		/*if(k>j) //if user is not in softer  
		{
			user[usr].handoff+=2;
		}*/
		if(k>0)
		{
			//user[usr].antennas[0]=ant;
			//the.users[usr].setCurAntenna(ant);
			return(k+1);
		}
		return(0);
	}

	private void writeResult(int step) {
        StringBuffer line = new StringBuffer();

        try 
		{
			fpower = new PrintStream(
            new FileOutputStream(fileName.toString()));
        } 
		catch (Exception e) 
		{
            the.asNeededPrintln("Problem when opening " + fileName.toString());
        }
        
        for (int i = 0; i < usrs; i++) 
		{
            line.setLength(0);
			line.append(new Format("%4d").form(step));
            line.append(" ");
            line.append(new Format("%4d").form(i));
            line.append(" ");
            
            line.append(new Format("%7.6f").form(the.users[i].getPrevPower()));
            line.append(" ");
            line.append(new Format("%7.6f").form(the.users[i].getCurPower()));
            line.append(" ");
            line.append(new Format("%2d").form(the.users[i].getPrevNumber()));
			line.append(" ");
			line.append(the.users[i].getPrevAntennaString() + " " 
				+ the.users[i].getPrevHandoffString());
			line.append(" ");
            line.append(new Format("%2d").form(the.users[i].getCurNumber()));
			line.append(" ");
			line.append(the.users[i].getCurAntennaString() + " " 
				+ the.users[i].getCurHandoffString());
            fpower.println(line.toString());
        }
        fpower.close();
    }
/*
int sector_stat(int s,int mode)
{
	switch(mode)
	{
	case 0: //Channels 
		if(sect[s].serving < channels-1)
			return(1);
		return(0);
		break;
	case 1: // Reserve channel/
		if(sect[s].serving < channels-1)
		{	
			sect[s].serving++;
			return(1);
		}
		return(0);
		break;
	case 2: // Deallocate channel
		if(sect[s].serving > 0)
		{	
			sect[s].serving--;
			return(1);
		}
		else
			sect[s].serving=0;
		return(0);
		break;
	}
}*/

}