

public class POCATSettings
{
	private double maxPower = 1.0; /*defualt values for max and min power*/
	private double minPower = 1e-6; 
	private int maxReps = 30;
	
	private double noise=1e-14;
	private int fadingModel = 0;
	private double handoffThreshold=0.25;
	private double cir=0.05; //carrier to interference ratio

	public POCATSettings()
	{
	}

	public void setMaxPower(double p)
	{
		maxPower = p;
	}

	public double getMaxPower()
	{
		return maxPower;
	}

	public void setMinPower(double p)
	{
		minPower = p;
	}

	public double getMinPower()
	{
		return minPower;
	}

	public void setMaxReps(int p)
	{
		maxReps = p;
	}

	public int getMaxReps()
	{
		return maxReps;
	}

	public void setNoise(double p)
	{
		noise = p;
	}

	public double getNoise()
	{
		return noise;
	}

	public void setFadingModel(int p)
	{
		fadingModel = p;
	}

	public int getFadingModel()
	{
		return fadingModel;
	}

	public void setHandoffThreshold(double f)
	{
		handoffThreshold = f;
	}

	public double getHandoffThreshold()
	{
		return handoffThreshold;
	}

	public void setCir(double c)
	{
		cir=c;
	}

	public double getCir()
	{
		return cir;
	}
}

