/*
 * SectorsPanel class
 *
 * Author: M. Heidi McClure
 * Date Started: 3/12/97
 * Date Last Revised: 4/12/97
 */
import java.awt.*;
/**
 * SectorsPanel is a class which is planned to allow for custom settings
 * of sectors.  That is, it would a way to create sector patterns on
 * the fly or read patterns from another file.
 * <p>
 * This class does not function completely.  It merely provides the
 * hooks to perform some parameterization of some of the variables used
 * in the model.
 * <p>
 * @author      M. Heidi McClure
 * @version UTMOST2 1.0
 * @see VariablesPanel
 * @see FilesPanel
 * @see UsersPanel
 * @see PropertySettings
 */
public class SectorsPanel extends Panel {

    private Label PanelTitle = new Label(
        "Sector Properties");


    private Label sSectorOverlapLabel = new Label("Sector Overlap:");
    private TextField sSectorOverlapText =   new TextField("15");
	private Label sSectorOverlapLabel2 = new Label("degrees on each side");

    private PropertySettings parent;
    private double sOverlap;

    /**
     * Constructor which will create a SectorPanel object.
     *
     * @param p is the PropertySettings panel object which called this
     * constructor
     */
    public SectorsPanel(PropertySettings p) {
        parent = p;

        setLayout(null);

        resize(insets().left + insets().right + 462, insets().top + insets().bottom + 306);

        add(PanelTitle);
        PanelTitle.reshape(insets().left + 24,insets().top + 24,400,20);

        add(sSectorOverlapLabel);
        sSectorOverlapLabel.reshape(insets().left + 24,insets().top + 64,120,20);
        
        add(sSectorOverlapText);
        sSectorOverlapText.reshape(insets().left + 155,insets().top + 64,40,30);

		add(sSectorOverlapLabel2);
        sSectorOverlapLabel2.reshape(insets().left + 200,insets().top + 64,200,20);
		
        /*
		add(uInitFileBrowse);
        uInitFileBrowse.reshape(insets().left + 360,insets().top + 80,88,30);

        add(uDotSizeLabel);
        uDotSizeLabel.reshape(insets().left + 24,insets().top + 176,160,20);
        add(uDotSizeText);
        uDotSizeText.reshape(insets().left + 200,insets().top + 176,80,30);
        */

    }

    public void setParent(PropertySettings p) {
        parent = p;
    }

    public double getSectorOverlap() {
        double v = (Double.valueOf(sSectorOverlapText.getText())).doubleValue();
		if (v >= 0 && v < 121 ){
			sOverlap=v;
			return (sOverlap);
		}
		else{
			sSectorOverlapText.setText("15");
			sOverlap=15;
			return (sOverlap);
		}
    }

    /*
     * action() method is for handling Button, TextField, Choice
     * and CheckBox action events ONLY. Geary, pg. 72 and 82-.
     */
    public boolean action(Event evt, Object arg) {

        if (evt.target == sSectorOverlapText) {
			(parent.getUTMOST2()).setSectorOverlap(getSectorOverlap());
        }

        return true;
    }

    public void updataValues() {
        (parent.getUTMOST2()).setSectorOverlap(getSectorOverlap());
    }

}

