/*
 * UsersPanel class
 *
 * Author: M. Heidi McClure
 * Date Started: 3/12/97
 * Date Last Revised: 4/12/97
 */
import java.awt.*;
/**
 * UsersPanel is a class which is planned to allow for custom settings
 * of users.  That is, it would provide a way to read in from a file the initial
 * state of all users in the model.  This panel would also allow for
 * changing of the user dot size.
 * <p>
 * This class does not function completely.  It merely provides the
 * hooks to perform some parameterization of some of the variables used
 * in the model.
 * <p>
 * @author      M. Heidi McClure
 * @version UTMOST2 1.0
 * @see VariablesPanel
 * @see FilesPanel
 * @see SectorPanel
 * @see PropertySettings
 */
public class UsersPanel extends Panel {
    private Label PanelTitle = new Label("UTMOST2 User Data");

    private Label uInitFileLabel =        new Label("Initial User Stats From:");
    private TextField uInitFileText =   new TextField("init_user_data");
    private Button uInitFileBrowse = new Button("Browse...");
    private Label uDotSizeLabel =       new Label("Size of User Dots:");
    private TextField uDotSizeText =   new TextField("10", 3);

    private PropertySettings parent;
    private String userInitFile;
    private int userDotSize;

    /**
     * Constructor which will create a UserPanel object.
     *
     * @param p is the PropertySettings panel object which called this
     * constructor
     */
    public UsersPanel(PropertySettings p) {
        parent = p;
/*
        // setup text height
        MyFontMetrics tfm = new MyFontMetrics(uInitFileText.getFont());
        int theight = tfm.getHeight();

        // setup label height
        MyFontMetrics lfm = new MyFontMetrics(uInitFileLabel.getFont());
        int lheight = lfm.getHeight();
*/
        setLayout(null);

        resize(insets().left + insets().right + 462, insets().top + insets().bottom + 306);

        add(PanelTitle);
        PanelTitle.reshape(insets().left + 24,insets().top + 24,
        200,20);

        add(uInitFileLabel);
        uInitFileLabel.reshape(insets().left + 24,insets().top + 60,
        180,20);
        add(uInitFileText);
        uInitFileText.reshape(insets().left + 24,insets().top + 80,
        320,30);
        add(uInitFileBrowse);
        uInitFileBrowse.reshape(insets().left + 360,insets().top + 80,
        88,30);

        add(uDotSizeLabel);
        uDotSizeLabel.reshape(insets().left + 24,insets().top + 176,
        160,20);
        add(uDotSizeText);
        uDotSizeText.reshape(insets().left + 200,insets().top + 176,
        80,30);

    }

    public void setParent(PropertySettings p) {
        parent = p;
    }
    public void setUserInitFile(String s) {
        userInitFile = s;
    }
    public void setUserDotSize(int i) {
        userDotSize = i;
    }

    /*
     * action() method is for handling Button, TextField, Choice
     * and CheckBox action events ONLY. Geary, pg. 72 and 82-.
     */
    public boolean action(Event evt, Object arg) {

        if (evt.target == uInitFileText) {
            userInitFile = uInitFileText.getText();
        }

        if (evt.target == uDotSizeText) {
            userDotSize = new Integer(uInitFileText.getText()).intValue();
        }

        return true;
    }

    public void updateValues() {
        /*
        userInitFile = uInitFileText.getText();
        userDotSize = new Integer(uInitFileText.getText()).intValue();
        */
    }
}

